/**********************************************
Pay an attention!

This code is designed for Arduino Mega board.

**********************************************/

/**********************************************
Define zone
**********************************************/
#define RS 38
#define WR 39
#define CS 40
#define RST 41



#define T_CLK 6
#define T_CS 5
#define T_DIN 4
#define T_DOUT 3
#define T_IRQ 2

#define X_CONST 176
#define Y_CONST 220

#define PREC_TOUCH_CONST 10

#define PixSizeX	13.78
#define PixOffsX	411

#define PixSizeY	11.01
#define PixOffsY	378

#define WINDOW_XADDR_START	0x0050 // Horizontal Start Address Set
#define WINDOW_XADDR_END	0x0051 // Horizontal End Address Set
#define WINDOW_YADDR_START	0x0052 // Vertical Start Address Set
#define WINDOW_YADDR_END	0x0053 // Vertical End Address Set
#define GRAM_XADDR		    0x0020 // GRAM Horizontal Address Set
#define GRAM_YADDR		    0x0021 // GRAM Vertical Address Set
#define GRAMWR 			    0x0022 // memory write

/* LCD color */
#define White          0xFFFF
#define Black          0x0000
#define Blue           0x001F
#define Blue2          0x051F
#define Red            0xF800
#define Magenta        0xF81F
#define Green          0x07E0
#define Cyan           0x7FFF
#define Yellow         0xFFE0

/**********************************************
Val Zone
**********************************************/
int TP_X,TP_Y;


/**********************************************
Standard C functions zone
**********************************************/

void Write_Command(unsigned int c)
{
    digitalWrite(RS,LOW);//LCD_RS=0; 
	digitalWrite(CS,LOW);//LCD_CS =0;	 
	PORTA = c>>8; //LCD_DataPortH=DH>>8;
	digitalWrite(WR,LOW);//LCD_WR=0;
	digitalWrite(WR,HIGH);//LCD_WR=1;	
	PORTA = c;//LCD_DataPortH=DH;		
	digitalWrite(WR,LOW);//LCD_WR=0;
	digitalWrite(WR,HIGH);//LCD_WR=1;
	digitalWrite(CS,HIGH);//LCD_CS =0;
}


void Write_Data(unsigned int c)
{
    digitalWrite(RS,HIGH);//LCD_RS=0;
	digitalWrite(CS,LOW);//LCD_CS =0;	 
	PORTA = c>>8; //LCD_DataPortH=DH>>8;
	digitalWrite(WR,LOW);//LCD_WR=0;
	digitalWrite(WR,HIGH);//LCD_WR=1;	
	PORTA = c;//LCD_DataPortH=DH;		
	digitalWrite(WR,LOW);//LCD_WR=0;
	digitalWrite(WR,HIGH);//LCD_WR=1;
	digitalWrite(CS,HIGH);//LCD_CS =0;
}

void Write_Command_Data(unsigned int cmd,unsigned int dat)
{
	Write_Command(cmd);
	Write_Data(dat);
}

void Lcd_Init()
{
	pinMode(RS,OUTPUT);
	pinMode(WR,OUTPUT);
	pinMode(CS,OUTPUT);
	pinMode(RST,OUTPUT);
	
	DDRA = 0xFF;
  
	digitalWrite(RST,HIGH);
    delay(1);	
	digitalWrite(RST,LOW);
	delay(1);
	
	digitalWrite(RST,HIGH);
	digitalWrite(CS,HIGH);
	digitalWrite(WR,HIGH);
	delay(20);

	
	Write_Command_Data(0x0026,0x0084); //PT=10,GON=0, DTE=0, D=0100
delay(40);
Write_Command_Data(0x0026,0x00B8); //PT=10,GON=1, DTE=1, D=1000
delay(40);
Write_Command_Data(0x0026,0x00BC); //PT=10,GON=1, DTE=1, D=1100


delay(20);                           //ӵʱ  080421    
// Write_Command_Data(0x0001,0x0000);     // PTL='1' Enter Partail mode

//Driving ability Setting
Write_Command_Data(0x0060,0x0000); //PTBA[15:8]
Write_Command_Data(0x0061,0x0006); //PTBA[7:0]
Write_Command_Data(0x0062,0x0000); //STBA[15:8]
Write_Command_Data(0x0063,0x00C8); //STBA[7:0]
delay(20);                        //ӵʱ   080421    

//Gamma Setting
Write_Command_Data(0x0073,0x0070); //
Write_Command_Data(0x0040,0x0000); //
Write_Command_Data(0x0041,0x0040); //
Write_Command_Data(0x0042,0x0045); //
Write_Command_Data(0x0043,0x0001); //
Write_Command_Data(0x0044,0x0060); //
Write_Command_Data(0x0045,0x0005); //
Write_Command_Data(0x0046,0x000C); //
Write_Command_Data(0x0047,0x00D1); //
Write_Command_Data(0x0048,0x0005); //

Write_Command_Data(0x0050,0x0075); //
Write_Command_Data(0x0051,0x0001); //
Write_Command_Data(0x0052,0x0067); //
Write_Command_Data(0x0053,0x0014); //
Write_Command_Data(0x0054,0x00F2); //
Write_Command_Data(0x0055,0x0007); //
Write_Command_Data(0x0056,0x0003); //
Write_Command_Data(0x0057,0x0049); //
delay(20);                          //ӵʱ     080421    

//Power Setting
Write_Command_Data(0x001F,0x0003); //VRH=4.65V     VREG1GAMMA 00~1E  080421    
Write_Command_Data(0x0020,0x0000); //BT (VGH~15V,VGL~-12V,DDVDH~5V)
Write_Command_Data(0x0024,0x0024); //VCOMH(VCOM High voltage3.2V)     0024/12    080421    11~40
Write_Command_Data(0x0025,0x0034); //VCOML(VCOM Low voltage -1.2V)    0034/4A    080421    29~3F 
//****VCOM offset**///
Write_Command_Data(0x0023,0x002F); //VMF(no offset)                            
delay(20);                          //ӵʱ  080421            10~39

//##################################################################
// Power Supply Setting
Write_Command_Data(0x0018,0x0044); //I/P_RADJ,N/P_RADJ Noraml mode 60Hz
Write_Command_Data(0x0021,0x0001); //OSC_EN='1' start osc
Write_Command_Data(0x0001,0x0000); //SLP='0' out sleep
Write_Command_Data(0x001C,0x0003); //AP=011
Write_Command_Data(0x0019,0x0006); // VOMG=1,PON=1, DK=0,
delay(20);                          //ӵʱ  080421    

//##################################################################
// Display ON Setting
Write_Command_Data(0x0026,0x0084); //PT=10,GON=0, DTE=0, D=0100
delay(40);
Write_Command_Data(0x0026,0x00B8); //PT=10,GON=1, DTE=1, D=1000
delay(40);
Write_Command_Data(0x0026,0x00BC); //PT=10,GON=1, DTE=1, D=1100
delay(20);                    //ӵʱ  080421    

//SET GRAM AREA
Write_Command_Data(0x0002,0x0000); 
Write_Command_Data(0x0003,0x0000); 
Write_Command_Data(0x0004,0x0000);
Write_Command_Data(0x0005,0x00AF);
Write_Command_Data(0x0006,0x0000);
Write_Command_Data(0x0007,0x0000);
Write_Command_Data(0x0008,0x0000);
Write_Command_Data(0x0009,0x00DB);

delay(20);                //ӵʱ  080421    
Write_Command_Data(0x0016,0x0008);  //MV MX MY ML SET  0028ʾʱWrite_Command_Data(0x0005,0x00DB);  Write_Command_Data(0x0009,0x00AF);
Write_Command_Data(0x0017,0x0005);//COLMOD Control Register (R17h)
  Write_Command (0x0021);//LCD_WriteCMD(GRAMWR)


	Write_Command(0x0022);
}
void SetXY(unsigned int x0,unsigned int x1,unsigned int y0,unsigned int y1)
{
  Write_Command_Data(0x0002,0x0000); 
  Write_Command_Data(0x0003,x0); 
  Write_Command_Data(0x0004,0x0000);
  Write_Command_Data(0x0005,y0);
   
  Write_Command_Data(0x0006,0x0000);
  Write_Command_Data(0x0007,x1);
  Write_Command_Data(0x0008,0x0000);
  Write_Command_Data(0x0009,y1); 

  Write_Command (0x0022);//LCD_WriteCMD(GRAMWR);
}
void Pant(unsigned int color)
{
	int i,j;
	SetXY(0,0,Y_CONST,Y_CONST);

    for(i=0;i<X_CONST;i++)
	 {
	  for (j=0;j<Y_CONST;j++)
	   	{
         Write_Data(color);
	    }

	  }		
}
void LCD_clear()
{
    unsigned int i,j;
	SetXY(0,0,Y_CONST,Y_CONST);
	for(i=0;i<X_CONST;i++)
	{
	    for(j=0;j<Y_CONST;j++)
		{    
          	Write_Data(0x0000);
		}
	}
}

void Touch_Init(void)
{
	pinMode(T_CLK,  OUTPUT);
    pinMode(T_CS,   OUTPUT);
    pinMode(T_DIN,  OUTPUT);
    pinMode(T_DOUT, INPUT);
    pinMode(T_IRQ,  INPUT);

	digitalWrite(T_CS,  HIGH);
	digitalWrite(T_CLK, HIGH);
	digitalWrite(T_DIN, HIGH);
	digitalWrite(T_CLK, HIGH);
}

void Touch_WriteData(unsigned char data)
{
	unsigned char temp;
	unsigned char nop;
	unsigned char count;

	temp=data;
	digitalWrite(T_CLK,LOW);

	for(count=0; count<8; count++)
	{
		if(temp & 0x80)
			digitalWrite(T_DIN, HIGH);
		else
			digitalWrite(T_DIN, LOW);
		temp = temp << 1; 
		digitalWrite(T_CLK, LOW);                
		nop++;
		digitalWrite(T_CLK, HIGH);
		nop++;
	}
}

unsigned int Touch_ReadData()
{
	unsigned char nop;
	unsigned int data = 0;
	unsigned char count;
	for(count=0; count<12; count++)
	{
		data <<= 1;
		digitalWrite(T_CLK, HIGH);               
		nop++;
		digitalWrite(T_CLK, LOW);
		nop++;
		if (digitalRead(T_DOUT))
			data++;
	}
	return(data);
}
void Touch_Read()
{
	unsigned long tx=0;
	unsigned long ty=0;

	digitalWrite(T_CS,LOW);                    

	for (int i=0; i<PREC_TOUCH_CONST; i++)
	{
		Touch_WriteData(0x90);        
		digitalWrite(T_CLK,HIGH);
		digitalWrite(T_CLK,LOW); 
		ty+=Touch_ReadData();

		Touch_WriteData(0xD0);      
		digitalWrite(T_CLK,HIGH);
		digitalWrite(T_CLK,LOW);
		tx+=Touch_ReadData();
	}

	digitalWrite(T_CS,HIGH);

	TP_X=tx/PREC_TOUCH_CONST;
	TP_Y=ty/PREC_TOUCH_CONST;
}

char Touch_DataAvailable()
{
  char avail;
  avail = !digitalRead(T_IRQ);
  return avail;
}

int Touch_GetX()
{
	int value;
	value = ((TP_X-PixOffsX)/PixSizeX);
	if (value < 0)
		value = 0;
	return value;
}
int Touch_GetY()
{
	int value;
	value = ((TP_Y-PixOffsY)/PixSizeY);
	if (value < 0)
		value = 0;
	return value;
}
/**********************************************
Arduino functions zone
**********************************************/
void setup()
{ 
  
  Lcd_Init();
  Touch_Init();
  LCD_clear();
	Pant(0xf800);
	Pant(0x07e0);
	Pant(0x001f);
	Pant(0xffff);
	Pant(0x0000);
}

void loop()
{
    unsigned int  i,j;
   	while(Touch_DataAvailable() == 1)
	{
		Touch_Read();
		i = Touch_GetX();
		j = Touch_GetY();
		SetXY(i,j,i,j);
		Write_Data(0xFFFF);
	}
 
  
}
